package com.dbxml.db.client.tools.command;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: Collection.java,v 1.6 2004/02/12 00:17:55 bradford Exp $
 */

import com.dbxml.db.client.CollectionClient;
import com.dbxml.db.client.tools.CommandLine;
import com.dbxml.util.dbXMLException;
import java.io.PrintWriter;

/**
 * Collection (COL) changes the current context Collection.
 *
 * @todo More advanced path navigation (similar to UNIX)
 */

public final class Collection extends CommandBase {
   public void process() throws dbXMLException {
      String colName = cl.getNextToken("Collection Name");
      CollectionClient col = (CollectionClient)cl.getProperty(CommandLine.COLLECTION);
      if ( col != null ) {
         if ( colName.equals("..") )
            col = col.getParentCollection();
         else if ( colName.equals(".") )
            col = col;
         else if ( colName.startsWith("/") )
            col = cl.getClient().getCollection(colName);
         else
            col = col.getCollection(colName);
      }
      else {
         if ( !colName.startsWith("/") )
            colName = '/' + colName;
         col = cl.getClient().getCollection(colName);
      }
      cl.setProperty(CommandLine.COLLECTION, col);

      PrintWriter pw = cl.getWriter();
      pw.println("Collection: "+col.getCanonicalName());
   }
}
